#!/bin/bash
# Create docker image
# FILE_PORT=5004
# IMAGE_NAME=openaiserver
# CONTAINER_NAME=openai
echo "*************************************************************"
echo "*** Deploy LTI api server for recommendation using OpenAI ***"
echo "*************************************************************"

# Adding required variable from configuration file
. ../config/ltiapiopenai.conf
echo $API_KEY
echo $ASS_ID
echo $ASS_PORT
echo $IP_ADDRESS
echo $IMAGE_NAME
echo $CONTAINER_NAME
echo $FILE_PORT
DASH_FILE="dashboard/issue_dashboard.json"
# Make sure that all python libraries are installed
sudo apt install python3-pip
pip3 install openai flask requests pipenv flask-cors mysql-connector numpy
# set the local environment variable with the content of the cofiguration file
export OPENAI_API_KEY=$API_KEY
export OPENAI_ASSISTANT_ID=$ASS_ID
export ASSISTANT_PORT=$ASS_PORT
export FILE_PORT=$F_PORT

newassist="n"
nameass=""
# Recommendations_openai_assistant_240411
read -p "Create a new assistant (y or n) : " newassist


if [ "$newassist" == "y" ]; then
    # create a new assistant here
    while [ -z ${nameass} ]
    do
        echo "Enter a name for the new assistant : " 
        read nameass
    done
    python3 assistant.py --name "$nameass"
    # if [ -f include/assid.conf ]; then
    #     . include/assid.conf
    #     export OPENAI_ASSISTANT_ID=$NEW_ASS_ID
    # fi
fi
# Build docker image
cd ..
docker build -t $IMAGE_NAME .
echo "Building image done ..."
# Launch the container
docker run -p 0.0.0.0:$ASS_PORT:$ASS_PORT -p 0.0.0.0:$FILE_PORT:$FILE_PORT --name openaiapi -e OPENAI_API_KEY -e OPENAI_ASSISTANT_ID -d $IMAGE_NAME
# 
# update dashboard json file
cp files/dash_template.json $DASH_FILE

FILE_LOCATION="http://$IP_ADDRESS:$FILE_PORT/share"
FILE_REPLACE="file_location_and_port"

API_ENDPOINT="http://$IP_ADDRESS:$ASS_PORT/api/recommendation"
ENDP_REPLACE="api_endpoint_address"

# Replace the old address using IP/PORT provided in configuration file

if [[ "$OSTYPE" == "darwin"* ]]; then
    # Mac OSX user
    echo "Mac Os User"
    sed -i "" "s@$FILE_REPLACE@$FILE_LOCATION@g" $DASH_FILE
    sed -i "" "s@$ENDP_REPLACE@$API_ENDPOINT@g" $DASH_FILE
elif [[ "$OSTYPE" == "linux-gnu"* ]]; then
    # linux user
    echo "Linux User"
    sed -i "s@$FILE_REPLACE@$FILE_LOCATION@g" $DASH_FILE
    sed -i "s@$ENDP_REPLACE@$API_ENDPOINT@g" $DASH_FILE
else
    # Others
    sed -i "" "s@$FILE_REPLACE@$FILE_LOCATION@g" $DASH_FILE
    sed -i "" "s@$ENDP_REPLACE@$API_ENDPOINT@g" $DASH_FILE
fi