import os
from openai import OpenAI
import requests
import time

# Create a new client
client = OpenAI(api_key=os.environ['OPENAI_API_KEY'])
assId = os.environ['OPENAI_ASSISTANT_ID']

# Function executing the request received from client 
def execReq(clientAi, requestAi, assistantId):
    # print(requestAi)
    # Create new thread for the message
    thread = clientAi.beta.threads.create(
        messages=[{
            "role": "user",
            "content": f"{requestAi}",
        }]
    )
    # Run the thread until the status of the run is completed
    run = clientAi.beta.threads.runs.create(
        thread_id=thread.id,
        assistant_id=f"{assistantId}"
    )

    while run.status != 'completed':
        run = clientAi.beta.threads.runs.retrieve(thread_id=thread.id, run_id=run.id)
        time.sleep(1)
    resu = clientAi.beta.threads.messages.list(thread.id)

    #  Return the result content to the function
    return resu.data[0].content[0].text.value


# Request to return all results including all ID
def execReqAll(clientAi, requestAi, assistantId):

    thread = clientAi.beta.threads.create(
        messages=[{
            "role": "user",
            "content": f"{requestAi}",
        }]
    )
    # Run the thread until the status of the run is completed
    run = clientAi.beta.threads.runs.create(
        thread_id=thread.id,
        assistant_id=f"{assistantId}"
    )

    while run.status != 'completed':
        run = clientAi.beta.threads.runs.retrieve(thread_id=thread.id, run_id=run.id)
        time.sleep(1)
    resu = clientAi.beta.threads.messages.list(thread.id)
    return resu

if __name__ == "__main__" :
    # req = 
    # {http : [25.05, 20.4, Above], https : [36.4, 21.50, Higher], tcp : [22.01, 21.90, Normal], udp : [20.05, 20.10, Normal], icmp : [52.30, 25.03, Higher], twamp : [25.50, 22.82, Above], period : [300, Seconds ]}
    # 'areasugg', 'http://3.96.178.105:5002/api/recommendation'
    # res = execReq(client,"http zero, https normal, udp high, tcp high, icmp normal, twamp zero", assId)
    rqst = '''
        {"apiRequest":"{http : [25.05, 20.4, Above], https : [36.4, 21.50, Higher], tcp : [22.01, 21.90, Normal], udp : [20.05, 20.10, Normal], icmp : [52.30, 25.03, Higher], twamp : [25.50, 22.82, Above], period : [15m, Minutes ], network:[1002,Latencetech]}"}
    '''
    res = execReqAll(client,rqst, assId)
    print(res)
